/* EM_UTIL_SCAN.C 910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"

char *index();   /* declare index to be a pointer type */
/*  NOTE.  The failure of get_cadd, get_add, etc. is signified by
    returning FAIL (-1).  em_scan currently ignores this information. */

em_fscanf()
{ int i, j;
  if(noex_bl < 0) {em_debug=3; printf("ERROR - negative noex_bl in em_fscanf\n");}
  if(em_debug == 2) printf("In scan, noex_bl=%d, save_bl=%d, called=%d, sub=%s, linenum=%d\n",
			    noex_bl,save_bl,called,&sub_file_stack[in_subs[in_sub]][0],linenum);
/*if(called == FALSE && quad_bl >= toqs_bl && source_bl != INPUT && in_sub <=0)*/  if(quad_bl >= toqs_bl && source_bl != INPUT)
	  {/*if (em_debug == 7) printf("Caution - resetting source_bl to INPUT, quad_bl=%d, toqs_bl=%d\n",
					quad_bl, toqs_bl);*/
					source_bl=INPUT;
/*					printf("fscanf at %d in %s (in_sub=%d) setting source_bl to %d\n",
						linenum, &sub_file_stack[in_subs[in_sub]][0], in_sub, source_bl);
	  printf("with noex_bl=%d, save_bl=%d, quad_bl=%d, toqs_bl=%d\n",
			    noex_bl,save_bl,quad_bl,toqs_bl);
			 printf("previous quad = %s %x\n",code_bl,command_bl);*/
    }
  if(source_bl == STACK)
    {if(em_debug == 3)
       printf(" STACK[%d,%d]=%s\n",quad_dx,quad_bl,(*quads_stk[quad_dx]).qpnt[quad_bl]);
     sscanf((*quads_stk[quad_dx]).qpnt[quad_bl],"%15s %x",code_bl,&command_bl);}
       /* em_scan_n updates quad_bl */
  else
   {if(fscanf(input_fp,"%15s %x",code_bl,&command_bl) == EOF)
       {printf("%d ERROR - EOF detected on intermediate file\n",linenum);
	return(EOF);}
    if(em_debug == 3) printf(" %s. quad_stk=%d, linenum=%d, noex_bl=%d, quad=%x\n",
			 &sub_file_stack[in_subs[in_sub]][0],quad_dx,linenum,noex_bl,command_bl);}

if(em_debug == 13)
 printf("At em_fscan, linenum=%d, routine%d=%s, quadruple = %x, sc_mem[6]=%d\n",
 linenum, in_sub, &sub_file_stack[in_subs[in_sub]][0], command_bl,sc_mem[6]);

if(em_debug_4>0)
printf("em_debug_1,2,3,4,5=%d, %d, %d, %d, %d\n",em_debug_1,em_debug_2,
	em_debug_3,em_debug_4,em_debug_5);
if(em_debug == 1)
   {printf("debug linenum code_bl command_bl brch_bl save_bl noew_bl, _sk, _ext\n");
    printf("%5d %8d %10s %7x%7d%7d%5d%8d%10d\n",em_debug,linenum,code_bl,command_bl,brch_bl
			       ,save_bl,noex_bl,noex_bl_sk,noex_bl_ext);}

  if(em_debug == 5)
	 { for(j=0;j<4;j++)
      {printf("Quadruple stack[%d](linenum=%d,quad_dx=%d)=\n",j,linenum,quad_dx);
		 for(i=0;i<2;i++)
			printf("i=%d       %s.\n",i,(*quads_stk[j]).qpnt[i]);}
/*     if(*sub_file != NULL) printf("in subroutine %s\n",sub_file);
			else printf("in main program\n");
	  for(i=in_sub; i>= 0; i--)
		 printf("sub_stack[%d]=%s\n",i,&sub_file_stack[in_subs[i]][0]);
       printf("quad_dx quad_bl quad_sc toqs_bl routine\n");
       for(i=0; i<NOOFSTK; i++)
	  {printf("%7d %7d %7d %7d %s\n",quads_dx[i],quads_bl[i],quads_sc[i],
					     toqss_bl[i], &sub_file_stack[in_subs[i]][0]);}
       printf("                        %s\n",&sub_file_stack[in_subs[in_sub]][0]);
printf("sub_file_stack sub_stk sub_toqs, stack_cnt=%d \n",stack_cnt);
for(i=0; i<stack_cnt; i++)
   printf("%14s %7d %7d\n",&sub_file_stack[i],sub_stk[i],sub_toqs[i]);
*/   }
  return(command_bl);
}

void em_scano_0()
{ if(source_bl == STACK)
    quad_bl++;
  else
	 sprintf((char *) buffer_bl,"%15s %x",code_bl,command_bl);
}

void em_scano_1()
{ if(source_bl == STACK)
    sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s",code_bl,&command_bl,carg1);
  else
    { fscanf(input_fp,"%s",carg1);
      sprintf((char *) buffer_bl,"%15s %x %s",code_bl,command_bl,carg1);
    };
}

int em_carg_1(int *arg1)
{
  *arg1 = get_caddo(carg1);
  return (get_size(carg1));
}

void em_scano_2()
{ if(source_bl == STACK)
   sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s %s",code_bl,&command_bl,carg1,carg2);
  else
    { fscanf(input_fp,"%s %s",carg1,carg2);
      sprintf((char *)buffer_bl,"%15s %x %s %s",code_bl,command_bl,carg1,carg2);
    };
}

int em_carg_2(int * arg1, int * arg2)
{ *arg1 = get_caddo(carg1);
  *arg2 = get_caddo(carg2);
  return (get_size(carg1));
}

void em_scano_3()
{ if(source_bl == STACK)
    sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s %s %s",code_bl,&command_bl,carg1,
	   carg2,carg3);
  else
    { fscanf(input_fp,"%s %s %s",carg1,carg2,carg3);
      sprintf((char *) buffer_bl,"%15s %x %s %s %s",code_bl,command_bl,carg1,carg2,
	      carg3);
    };
}

int em_carg_3(int *arg1, int *arg2, int * arg3)
{
  *arg1 = get_caddo(carg1);
  *arg2 = get_caddo(carg2);
  *arg3 = get_caddo(carg3);
  return(get_size(carg1));
}

int em_carg_3p(int *arg2)
{
  *arg2 = get_caddo(carg2);
  return(get_size(carg2));
}

void em_scano_4()
{
  if(source_bl == STACK)
    sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s %s %s %s",
	   code_bl,&command_bl,carg1,carg2,carg3,carg4);
  else
    { fscanf(input_fp,"%s %s %s %s",carg1,carg2,carg3,carg4);
      sprintf((char *) buffer_bl,"%15s %x %s %s %s %s",code_bl,command_bl,carg1,carg2,
	      carg3,carg4);
    };
}

int em_carg_4(int *arg1, int *arg2, int * arg3, int * arg4)
{
  *arg1 = get_caddo(carg1);
  *arg2 = get_caddo(carg2);
  *arg3 = get_caddo(carg3);
  *arg4 = get_caddo(carg4);
  return(get_size(carg1));
}

void em_scano_5()
{ if(source_bl == STACK)
    sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s %s %s %s %s",
	   code_bl,&command_bl,carg1,carg2,carg3,carg4,carg5);
  else
    { fscanf(input_fp,"%s %s  %s %s %s",carg1,carg2,carg3,carg4,carg5);
     sprintf((char *) buffer_bl,"%15s %x %s %s %s %s %s",code_bl,command_bl,carg1,carg2
	     ,carg3,carg4,carg5);
    };
}

int em_carg_5(int *arg1, int * arg2, int * arg3, int * arg4, int * arg5)
{
  *arg1 = get_caddo(carg1);
  *arg2 = get_caddo(carg2);
  *arg3 = get_caddo(carg3);
  *arg4 = get_caddo(carg4);
  *arg5 = get_caddo(carg5);
  return(get_size(carg1));
}

void em_scano_6()
{ if(source_bl == STACK)
    sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s %s %s %s %s %s",
	   code_bl,&command_bl,carg1,carg2,carg3,carg4,carg5,carg6);
  else
    { fscanf(input_fp,"%s %s  %s %s %s %s",carg1,carg2,carg3,carg4,carg5,carg6);
     sprintf((char *)buffer_bl,"%15s %x %s %s %s %s %s %s",code_bl,command_bl,carg1,carg2
	     ,carg3,carg4,carg5,carg6);
    };
}

int em_carg_6(int * arg1, int * arg2, int * arg3, int * arg4, int * arg5, int * arg6)
{
  *arg1 = get_caddo(carg1);
  *arg2 = get_caddo(carg2);
  *arg3 = get_caddo(carg3);
  *arg4 = get_caddo(carg4);
  *arg5 = get_caddo(carg5);
  *arg6 = get_caddo(carg6);
  return(get_size(carg1));
}

void em_scano_9()
{ if(source_bl == STACK)
    sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s %s %s %s %s %s %s %s %s",
	   code_bl,&command_bl,carg1,carg2,carg3,carg4,carg5,carg6,carg7,carg8,carg9);
  else
    { fscanf(input_fp,"%s %s  %s %s %s %s %s %s %s",
				 carg1,carg2,carg3,carg4,carg5,carg6,carg7,carg8,carg9);
     sprintf((char *)buffer_bl,"%15s %x %s %s %s %s %s %s %s %s %s",
				code_bl,command_bl,carg1,carg2,carg3,carg4,carg5,carg6,carg7,carg8,carg9);
    };
}

int em_carg_9(int * arg1, int * arg2, int * arg3, int * arg4, int * arg5,
			   int * arg6, int * arg7, int * arg8, int * arg9)
{
  *arg1 = get_caddo(carg1);
  *arg2 = get_caddo(carg2);
  *arg3 = get_caddo(carg3);
  *arg4 = get_caddo(carg4);
  *arg5 = get_caddo(carg5);
  *arg6 = get_caddo(carg6);
  *arg7 = get_caddo(carg7);
  *arg8 = get_caddo(carg8);
  *arg9 = get_caddo(carg9);
  return(get_size(carg1));
}

void em_stack_buf()
/* If save flag is on, this routine moves buffer_bl to string
   memory, puts pointer on the quadruple stack indexed by quad_dx */
{
  char *pointer;
  int leng;

  if(save_bl > 0 && source_bl==INPUT)
    {leng = strlen((char *)buffer_bl)+1;
     if((pointer = (char *)em_alloc((unsigned long)leng,(unsigned long)sizeof(char))) == NULL)
       {printf("ERROR - NULL return from farcalloc in em_stack_buf, leng=%d\n",leng);
        dumpstack();
        em_exit(1);}
     strcpy(pointer,(char *) buffer_bl);
     em_push_quads(pointer);
    }
  else if(save_bl <= 0 && source_bl==INPUT) em_garbage();
/*
printf("In stack buf, Toqs_bl=%d, Quadruple stack[%d]=\n",toqs_bl,quad_dx);
for(i=0;i<10;i++)
  printf("       %s\n",(*quads_stk[0]).qpnt[i]);
  */
}

void em_stack_msg(char *message)
/* If save flag is on, this routine moves buffer_bl to string
   memory, puts pointer on the quadruple stack   */
{
  char *pointer;
  int leng;

  if(save_bl > 0 && source_bl==INPUT)
    {leng = 100;
     if((pointer = (char *)em_alloc((unsigned long)leng,(unsigned long)sizeof(char))) == NULL)
       {printf("ERROR - 0 return from farcalloc in em_stack_msg\n");
	     em_exit(1);}
      sprintf(buffer_bl,"%15s %x ",code_bl,command_bl);
		strcpy(pointer,buffer_bl);
		strcat(pointer,message);
      em_push_quads(pointer);
    };
}

void em_push_quads(char *pointer)
{  qspnt *address;

   if(toqs_bl<Q_STACK_SIZE/NOOFSTK)
		{/* print statements for quads_bl at end of file */
if(em_debug == 3)
   {address = quads_stk[quad_dx];
	printf("In push_quads, quad_dx=%d, toqs_bl=%d, address=%p\n",
            quad_dx, toqs_bl, address);
   }
		(*quads_stk[quad_dx]).qpnt[toqs_bl++] = pointer;
      }
   else
		{printf("ERROR - Quadruple stack overflow], toqs_bl=%d, quad_dx=%d\n",
					toqs_bl, quad_dx);
       dumpstack();
       em_exit(1);}
}

void em_pop_quads()
{
   toqs_bl--;
}


void em_garbage()
{
 
/* dump of quads_stk data  */

 if(toqs_bl > 0)
  {while(toqs_bl-- > 0)
    if((*quads_stk[quad_dx]).qpnt[toqs_bl] != NULL)
		 em_free((unsigned long *) (*quads_stk[quad_dx]).qpnt[toqs_bl]);
   toqs_bl=0;
   quad_bl=0;
   source_bl = INPUT;
  }


}

void em_push_loop()
{
   if(tols_bl<L_STACK_SIZE/NOOFSTK)
     if(source_bl == STACK)
        loops_bl[tols_bl++][in_sub]=quad_bl;
     else
		  loops_bl[tols_bl++][in_sub]=toqs_bl;
   else  printf("ERROR - Loop stack overflow\n");
}

void em_pop_loop()
{
   tols_bl--;
}

void em_push_bl(int arg1)
{
   if(gbl_bl<GBL_STACKSIZE) global[gbl_bl++] = arg1;
   else  printf("ERROR - Global stack overflow\n");
}

int em_pop_bl()
{
  int i;

   if(gbl_bl > 0)   i= global[--gbl_bl];
   else  printf("ERROR - Global stack underflow\n");
   return (i);
}


/* rscan - raw scan - does not translate symbols to addresses
                      returns them as ascii strings     */

void em_rscan_3(char *arg1, char * arg2, char *arg3)
{
  if(source_bl == STACK)
    sscanf((*quads_stk[quad_dx]).qpnt[quad_bl++],"%15s %x %s %s %s",
				code_bl,&command_bl,arg1,arg2,arg3);
  else
    { fscanf(input_fp,"%s %s %s",arg1,arg2,arg3);
      sprintf(buffer_bl,"%15s %x %s %s %s",code_bl,command_bl,arg1,arg2,arg3);}
  return;
}


/* get_cadd checks arg for a string of ascii digits.  If all are digits
   the string is converted to binary, otherwise, get_add is called.  In
   every case, a number, integer, (address) is returned
*/
int get_caddo(char *arg)
{
  int result;
  char *sarg;

  sarg = arg;
  while (*sarg != 0)
    {if(*sarg<'0' || *sarg++ > '9')
       { if((result = get_addo(arg)) != FAIL)
           return (result);
         else
	      return(FAIL);
       };
   };
  result = atoi(arg);
  return (result);
}


/* get_addo parses address+5,offset into address+5 and offset.
   Must also handle address,offset+2 into address and (offset+2).
   If offset is present, it generates the address
       getadd(address+5)+sc_mem[getadd(offset)]
   otherwise
       getadd(address+5)            */

int get_addo(char *arg)
{
  int ind1, ind2, val;
  char *pnt;
  if (em_debug == 2)
	  printf("In get_addo, arg=%s\n",arg);

  if((pnt = index_ss(arg,",")) != NULL) /* returns 0 if fail */
    {*pnt=0;
     if(((ind1=get_add(arg)) != FAIL) && ((ind2=get_addo(pnt+1)) != FAIL))
	   {val = ind1+sc_mem[ind2];
		 return(val);}
     else
		{get_add(arg);
		 /*dump_symtab();*/}
    }
  else
  if((pnt = index_ss(arg,"+")) != NULL) /* returns 0 if fail */
    {*pnt=0;
     if((ind1=get_add(arg)) != FAIL)
	    {val = ind1+atoi(pnt+1);
        return(val);}
     else {printf("ERROR - + arg %s not found in get_caddo\n",arg);
		     dump_symtab();}
    }
  else
    {if((val = get_add(arg)) != FAIL)
       return(val);
     else
       return FAIL;
    }
  return FAIL;
}

void push_sub()
{int i, savei, newsub;

/*em_debug = 5;*/
   quads_sc[in_sub] = source_bl;
   toqss_bl[in_sub] = toqs_bl;
   tolss_bl[in_sub] = tols_bl;
   quads_bl[in_sub] = quad_bl;
	quads_dx[in_sub] = quad_dx;
   quad_bl = 0;
   newsub = 1;
   for(i=0;i<SUB_DEPTH;i++)
     if(strcmp(&sub_file_stack[i][0],sub_file)==0)
		 {savei=i; newsub = 0;
		 break;}
   if(newsub == 1)
     {if((input_fp = fopen(sub_file,"r")) == NULL)
        {printf("Can't open %s\n",sub_file);
		   em_exit(1);}
      if(in_sub >= SUB_DEPTH)
	     printf("ERROR - Subroutine depth limit exceeded.\n");
      else
	    {in_sub++;
	     sub_stack[in_sub] = input_fp;
        in_subs[in_sub] = stack_cnt++;
	     strcpy(&sub_file_stack[in_subs[in_sub]][0],sub_file);
        toqs_bl = sav_toqs[in_sub];
		  sub_toqs[in_subs[in_sub]] = toqs_bl;
        quad_dx = in_sub;
		  sub_stk[in_subs[in_sub]] = quad_dx;
        called = FALSE;
 	     source_bl = INPUT;
        }
     }
	else
	  {in_sub++;
      source_bl = STACK;
		in_subs[in_sub] = savei;
      quad_dx = sub_stk[savei];
      quad_bl = sub_toqs[savei];
      toqs_bl = sav_toqs[in_sub];
      called = TRUE;
      /*printf("In push_sub, reentry savei=%d,quad_dx=%d,quad_bl=%d\n",
			  savei, quad_dx, quad_bl);                             */
		}
   calleds[in_sub]  = called;
	saves[in_sub]    = save_bl;
   quads_sc[in_sub] = source_bl; /*save for end_lp */
/*
printf("After push sub\n");
printf("quad_dx quad_bl quad_sc toqss_bl in_subs routine, in_sub=%d\n",in_sub);
for(i=0; i<= in_sub; i++)
   {printf("%7d %7d %7d %7d %7d %s\n",quads_dx[i],quads_bl[i],quads_sc[i],
				toqss_bl[i], in_subs[i], &sub_file_stack[in_subs[i]][0]);
	}
printf("                             %7d %s\n",toqs_bl,&sub_file_stack[in_subs[in_sub]][0]);
printf("sub_file_stack sub_stk sub_toqs, sav_toqs, stack_cnt=%d \n",stack_cnt);
for(i=0; i<stack_cnt; i++)
   printf("%14s %7d %7d %7d\n",&sub_file_stack[i],sub_stk[i],sub_toqs[i],sav_toqs[i]);
*/
}

void pop_sub()
{

  if(in_sub <= 0)
	 {printf("ERROR - Subroutine stack underflow.\n"); em_exit(1);}
  else
	 {sub_stack[in_sub] = 0;
     if(source_bl == INPUT) sav_toqs[in_sub] = toqs_bl;
     called =  calleds[in_sub];
	  save_bl = saves[in_sub];
	  in_sub--;
     quad_dx = quads_dx[in_sub];
	  quads_dx[in_sub] = 0;
	  quad_bl = quads_bl[in_sub];
	  source_bl = quads_sc[in_sub];
	  input_fp = sub_stack[in_sub];
     toqs_bl = toqss_bl[in_sub];
     tols_bl = tolss_bl[in_sub];
/*     if(in_sub <= 0) called = FALSE;*/
/*
printf("Pop_sub, returning to: quad_dx=%d, quad_bl=%d\n", quad_dx, quad_bl);
printf("sub_file_stack sub_stk sub_toqs, sav_toqs, stack_cnt=%d \n",stack_cnt);
for(i=0; i<stack_cnt; i++)
   printf("%14s %7d %7d %7d\n",&sub_file_stack[i],sub_stk[i],sub_toqs[i],sav_toqs[i]);
*/
	 }
}

/* dump of quads_bl data
printf(" address contents    table    data, toqs_bl=%d\n",toqs_bl);
printf("%8lx %8lx %8lx %8lx \n",&quads_stk, quad_dx, quads_stk[quad_dx], (*quads_stk[quads_dx]).qpnt[0], *(*quads_bl).qpnt[0]);
*/
