###########################################################
###########################################################
.SUFFIXES: .h .c .o


###########################################################
###########################################################

CC = /usr/bin/gcc
ASC2_OBJS = em_c_ari.o \
em_c_dec.o \
em_c_io.o \
em_c_mov.o \
em_comma.o \
em_c_stm.o \
em_dimp.o \
em_load.o \
em_n_ari.o \
em_quads.o \
em_r_ari.o \
em_r_cmp.o \
em_r_fin.o \
em_r_io.o \
em_r_log.o \
em_r_mov.o \
em_u_sca.o \
em_u_tab.o \
p2_auxil.o \
p2_conve.o \
p2_main_.o \
p2_main.o \
p2_print.o \
p2_util.o 


###########################################################
###########################################################
all: asc2

###########################################################
###########################################################
asc2: $(ASC2_OBJS)
	$(CC) $(ASC2_OBJS) -o asc2 -lm

.c.o:
	gcc -c $<

clean:
	rm -f core *.o *~ asc2

unix:
	mv *.o asc2 debug
