#ifndef P2_PARSER
#define P2_PARSER

#define W_REAL		32	/* bit field width for real */
#define W_INT		16	/* bit field width for integer */
#define W_LOGICAL	1	/* bit field width for logical */
#define W_LONGINT	32	/* bit field width for long integer */
#define W_OCT           16      /* bit field width for octal */
#define W_CHAR          8       /* bit field width for character */
#define W_EXPT          8       /* default length for real exponent */
#define W_SIGNIF        24      /* default length for real mantisa */
#define W_CARD		16	/* bit field width for cardinal */
#define W_BIN       	16	/* bit field width for integer */
#define W_HEX		16	/* bit field width for integer */

#define M_REAL		16	/* minimum bit field width for real */
#define M_INT		2 	/* minimum bit field width for integer */
#define M_LOGICAL	1	/* minimum bit field width for logical */
#define M_INDEX         1	/* minimum bit field width for index */
#define M_OCT           2       /* minimum bit field width for octal */
#define M_CHAR          8       /* minimum bit field width for character */
#define M_EXPT          8       /* minimum length for real exponent */
#define M_SIGNIF        16      /* minimum length for real mantisa */
#define M_CARD		1 	/* minimum bit field width for cardinal */
#define M_BIN		2 	/* minimum bit field width for integer */
#define M_HEX		2 	/* minimum bit field width for integer */
#endif
