#ifndef P2_PROTOTYPES
#define P2_PROTOTYPES

/* FUNCTION DECLARATIONS */
#include "stdio.h"
#include "stdlib.h" // for malloc, sizeof, itoa
//void itoa(int, char *);
//void ltoa(unsigned long int, char *, int);
//void srand(int);
//int atoi(char *);

void    print_msg();            /* print error and warning messages */

FILE    *fopen();               /* system routine to open a file */
int fixmode(int);
void em_scano_3();
void em_stack_buf();
int get_size(char *);
int put_size(char *, int);
void fxpaadsb(int, int, int, int, int);
void pasnexmk(int, int, int, int);
void flpaad(int, int, int, int);
int get_add(char *);
int em_chrcnv(int, int, int);
void fxcladsb2(int, int, int, int, int, int);
void flcmadd(int, int, int, int);
void fxcradsb2(int, int, int, int, int, int);
void flcmaddcr(int, int, int, int);
void fxscadsb(int, int, int, int, int);
void flscad(int, int, int, int);
void liscadsb(int, int, int, int);
void fxpaml(int, int, int, int);
void fxcrml2(int, int, int, int, int);
void fxscml(int, int, int, int);
void liscml(int, int, int);
int checksize_3();
void fxpamd(int, int, int);
void fxclmd2(int, int, int, int, int);
void fxcrmd2(int, int, int);
void fxscmd(int, int, int);
void liscmd(int, int, int);
void fxpadv(int, int, int, int);
void fxcldv2(int, int, int, int, int);
void fxcrdv2(int, int, int, int, int);
void fxscdv(int, int, int, int);
void liscdv(int, int, int);
void fxpalt(int, int, int, int);
void lgpaand(int, int, int, int);
void inc_pa_perform(int);
void fxcrlt2(int, int, int, int, int);
void fxcrgt2(int, int, int, int, int);
void fxcrle2(int, int, int, int, int);
void fxcrge2(int, int, int, int, int);
void fxcreq(int, int, int, int);
void fxcreq2(int, int, int, int, int);
void fxcrne2(int, int, int, int, int);
void flcmcmp(int, int, int, int);
void flsccmp(int, int, int, int);
void flpacmp(int, int, int, int);
void fxsclt(int, int, int, int, int);
void fxpale(int, int, int, int);
void fxpaeq(int, int, int, int);
void fxpane(int, int, int, int);
void fxpagt(int, int, int, int);
void fxpage(int, int, int, int);
void fxscle(int, int, int, int, int);
void fxscne(int, int, int, int, int);
void fxsceq(int, int, int, int, int);
void fxscgt(int, int, int, int, int);
void fxscge(int, int, int, int, int);
void em_print_err(int,int);
int nw_chrcnv(int, int, int);
void lgpaor(int, int, int, int);
void lgpaxor(int, int, int, int);
void lgcrxor(int, int, int, int);
void lgscxor(int, int, int, int);
void lgcror(int, int, int, int);
void lgscor(int, int, int, int);
void lgcrand(int, int, int, int);
void lgscand(int, int, int, int);
void em_scano_2();
void fxpamin(int, int, int);
void fxscmin(int, int, int);
void lgpanot(int, int, int);
void lgscnot(int, int, int);
void papamvmk(int, int, int, int);
void papamvun(int, int, int);
void scscmv(int, int, int);
void print_err(char *, int, int);
void pa_float(int, int, int);
void sc_float(int, int, int);
int pa_iterate(int, int, int, int, int, int);
int sc_fix(int, int);
int em_insert(int, int, char *, int, int, int, int, float, char *);
int fetch(char *);
int get_caddo(char *);
int * em_alloc(unsigned long, unsigned long);
void * em_malloc(unsigned long);
int balloc(int, int, int);
void talloc(int);
void em_free(void *);
void em_scano_0();
void em_scano_1();
void em_scano_2();
void em_scano_3();
void em_scano_4();
void em_scano_5();
void em_scano_6();
void em_scano_9();
int em_carg_1(int *);
int em_carg_2(int *, int *);
int em_carg_3(int *, int *, int *);
int em_carg_3p(int *);
int em_carg_4(int *, int *, int *, int *);
int em_carg_5(int *, int *, int *, int *, int *);
int em_carg_6(int *, int *, int *, int *, int *, int *);
int em_carg_9(int *, int *, int *, int *, int *, int *, int *, int *, int *);
float get_value(char *);
void paclrmk(int, int, int);
void paclrun(int, int);
int em_responders(int);
void pascmv(int, int, int, int);
void pascmvsx(int, int, int, int);
void step(int,int);
void printbin(int);
char * em_strcat(char *, int);
void em_strcpy(int, char *);
void fprintbin(FILE*, int);
void em_rscan_3(char *, char *, char *);
void expand(int, int, int);
void scanbin(char *, int *);
void pdump(int, int, int);
void minipdump(int, int, int);
void scpamvmk(int, int, int , int, int);
int first(int);
void em_stack_sc(int);
void em_pop_sc(int);
void infname(int, int, int, int *, int, int, int, int);
int em_scsize(long, long);
int mindex(int, int, int, int);
int scsize(long);
int pvalue(int);
int firstsc(long);
int em_firstsc(long, long);
int encode16(int, int);
int decode16(char *, int);
void movchr(int, int, int, int);
int em_cnvchr(int, int, int);
void em_mvpa(int, int, int, int, int);
void maskit(int, int);
void papamvmkhl(int, int, int, int);
void papamvsh(int, int, int, int, int, int);
void em_begin();
int em_while(int);
void em_stack(int);
void resvfst(int);
void em_pop(int);
void em_end_lp();
int brch_tst(int);
void em_push_bl(int);
int em_pop_bl();
void em_garbage();
void em_until(int, int, int);
void em_push_loop();
void em_pop_loop();
int em_fscanf();
void em_ident();
void em_include();
void em_clrarray();
void em_initstack();
void em_label();
void em_stop();
void em_end();
void em_setscope();
void em_stack_scope();
void em_pop_scope();
void em_assemble();
int em_declare();
int em_short(int);
void em_entry();
void em_extrn();
int em_fix(int);
int em_float(int);
int em_intchr(int);
int em_chrint(int);
int em_opcode(int, int);
int em_not(int);
int em_minusplus(int,int);
void em_control();
void em_allocate();
void em_release();
void em_resfst();
void em_main(int);
void em_subroutine();
void em_endmain();
void em_endsub();
int em_deflog();
int em_defvar();
void em_call();
int em_getadd();
int em_declar();
void em_return();
int em_move(int, int);
void em_mvpaid();
int em_mvid(int);
int em_mvcb();
void em_mindex();
void em_minval();
void em_maxdex();
void em_nthdex();
void em_nthval();
void em_bos();
void em_stcd();
void em_stcd8();
void em_msg();
void em_sibdex();
void em_count();
void em_sum();
void em_maxval();
int em_encode(int);
int em_decode(int);
int em_sqrt(int);
int em_exp(int);
int em_power(int);
int em_sin(int);
int em_cos(int);
int em_rand(int);
void em_tkncmp(int);
void em_hit(int);
int em_open();
int em_close();
int em_copy();
int em_clear(int);
void em_fstout();
void em_outpt(int);
void em_colapse(int);
void em_begprint(int);
void em_print(int);
void em_print_del(int);
void em_printnl();
void em_endprint();
void em_begread(int);
void em_readln(int);
int em_read(int);
void em_endread();
void em_ioalloc(int);
void em_expand(int);
void em_input(int);
void em_stack_gen(int);
void em_pop_gen(int);
void em_poprc(int);
void em_dump(int);
int em_dimp(int);
void em_lex(int);
int em_scin(int);
void em_scot(int);
void em_shape();
void em_scareg();
void em_regsca();
void em_dash();
int em_adj();
void em_noun();
int em_stack_temp(int);
void fxpaad(int,int,int,int);
void em_pop_temp(int);
void toascl(int, long int);
void push_sub();
void minval(int, int, int, int);
void maxdex(int, int, int, int);
void maxval(int, int, int, int);
void em_stack_field(int, int);
void em_pop_field(int, int);
void pop_sub();
int em_fndzo(long int);
int em_fndzo8(int);
int em_fndz8(int);
int em_fndnz8(int);
int count(int);
void pa_hit(int, int, int, int, int);
void sc_hit(int, int, int, int, int, int);
int sum(int, int, int, int);
void sibdex(int, int, int, int);
int sc_exp(int, int);
int sc_power(int, int, int);
int sc_sin(int, int);
int sc_cos(int, int);
int sc_rand(int);
int sc_sqrt(int, int);
void fxpaadun(int, int, int, int);
void scpamvun(int, int, int);
void inc_sc_perform(int);
int flpasm(int, int);
void fxcrne(int, int, int, int);
void fxcrad2(int, int, int, int, int);
void fxcrsb(int, int, int, int);
void fxcrml(int, int, int, int);
void fxcrlt(int, int, int, int);
void fxcrdv(int, int, int, int);
void fxcrad(int, int, int, int);
void fxcrle(int, int, int, int);
void wordmvmk(unsigned int, int, int, int, int);
void wordmvun(unsigned int, int, int);
void wdpascmv(int, int, int, int, int);
void wdpascsx(int, int, int, int, int);
void dumpstack();
void em_push_quads(char *);
int get_addo(char *);
void dump_symtab();
int gethash(char *);
int cm_fetch(char *);
void cm_print_err(int, int);
char *index_ss(char *, char *);
int time(int *);
int em_commands();
void em_exit(int);
void init_symtab();
void em_load(int);
void dump_atab();
void em_store(int);
void gen_line_delim(FILE *, int, int);
void gen_col_delim(FILE *, int);
char *em_catstr(char *, int, int);
char *make_shape(int);
char *make_head_shape(int);
int shape_size(char *);
void em_itoa(int, char *);

#endif



